// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package shop

import (
	"context"
	"errors"
	"time"

	"juwan-backend/app/shop/api/internal/svc"
	"juwan-backend/app/shop/api/internal/types"
	"juwan-backend/app/shop/rpc/pb"
	"juwan-backend/common/utils/contextj"

	"github.com/zeromicro/go-zero/core/logx"
)

type InvitePlayerLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// 邀请打手
func NewInvitePlayerLogic(ctx context.Context, svcCtx *svc.ServiceContext) *InvitePlayerLogic {
	return &InvitePlayerLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *InvitePlayerLogic) InvitePlayer(req *types.InvitationReq) (resp *types.EmptyResp, err error) {
	userID, err := contextj.UserIDFrom(l.ctx)
	if err != nil {
		return nil, err
	}

	shop, err := l.svcCtx.ShopRpc.GetShopsById(l.ctx, &pb.GetShopsByIdReq{Id: req.Id})
	if err != nil {
		return nil, err
	}
	if shop.Shops == nil {
		return nil, errors.New("shop not found")
	}
	if shop.Shops.OwnerId != userID {
		return nil, contextj.ERRILLEGALUSER
	}

	_, err = l.svcCtx.ShopRpc.AddShopInvitations(l.ctx, &pb.AddShopInvitationsReq{
		ShopId:      req.Id,
		PlayerId:    req.PlayerId,
		Status:      "pending",
		InvitedBy:   userID,
		CreatedAt:   time.Now().Unix(),
		RespondedAt: 0,
	})
	if err != nil {
		return nil, err
	}

	return &types.EmptyResp{}, nil
}
